/***** BEGIN LICENSE BLOCK *****
   - Version: MPL 1.1/GPL 2.0/LGPL 2.1
   -
   - The contents of this file are subject to the Mozilla Public License Version
   - 1.1 (the "License"); you may not use this file except in compliance with
   - the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License.
   -
   - The Original Code is the Copy URL+.
   - 
   - The Initial Developer of the Original Code is Philip Mateescu.
   - Portions created by the Initial Developer are Copyright (C) 2002-2003
   - the Initial Developer. All Rights Reserved.
   -
   - Contributor(s): Philip Mateescu <xbiker @ yahoo.com>
   - Thanks to  IMGTAG (Ted Mielczarek, Jedrek Kostecki) for unknowingly 
   - allowing me to shamelessly borrow their clipboard copy code.
   -
   - Alternatively, the contents of this file may be used under the terms of
   - either the GNU General Public License Version 2 or later (the "GPL"), or
   - the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   - in which case the provisions of the GPL or the LGPL are applicable instead
   - of those above. If you wish to allow use of your version of this file only
   - under the terms of either the GPL or the LGPL, and not to allow others to
   - use your version of this file under the terms of the MPL, indicate your
   - decision by deleting the provisions above and replace them with the notice
   - and other provisions required by the LGPL or the GPL. If you do not delete
   - the provisions above, a recipient may use your version of this file under
   - the terms of any one of the MPL, the GPL or the LGPL.
   -
   - ***** END LICENSE BLOCK *****/


function copyToClipboard(copyThis) {
	
	var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	if (!str) return false; // couldn't get thingamajig
	str.data = copyThis; // unicode string?
	
	var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
	if (!trans) return false; //no transferable widget found
	
	trans.addDataFlavor("text/unicode");
	trans.setTransferData("text/unicode", str, copyThis.length*2); // *2 cuz it's unicode
	
	var clipid=Components.interfaces.nsIClipboard;
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
	if (!clip) return false; // couldn't get the clipboard
	
	clip.setData(trans, null, clipid.kGlobalClipboard);
}


function getCurrentBrowser() {
	var latestBrowser = null;
	var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
							   .getService(Components.interfaces.nsIWindowMediator);
	var browserWindow = windowMediator.getMostRecentWindow("navigator:browser");

	if (browserWindow) {
		latestBrowser = browserWindow.getBrowser();
	}
	return latestBrowser;
}


function getCurrentSelection() {
	var focusedWindow = document.commandDispatcher.focusedWindow;
	var selection = focusedWindow.__proto__.getSelection.call(focusedWindow).toString();
	
	return selection;
}


function doCopyURLPlus(mode) {
	var focusedWindow = document.commandDispatcher.focusedWindow;
	var title = focusedWindow.document.title;
	var url = focusedWindow.location.href;
	var sel = getCurrentSelection();
	
	var copytext = '';
	switch (mode) {
		case 'title':
			copytext = title;
			break;
		case 'titlesel':
			copytext = title + "\n\"" + sel + '"';
			break;
		case 'sel':
			copytext = '"' + sel + '"';
			break;
		default:
			alert('Unknown copy mode requested:'
				+ "\n mode=" + mode + 
				+ "\n title=" + title
				+ "\n url=" + url
				+ "\n sel=" + sel
			);
			return;
	}
	//~ copytext += "\n[ " + url + " ]";
	copytext += "\n" + url;
	copyToClipboard(copytext);
	//~ alert("will have copied this to clipboard:\n" + copytext
			//~ + "\n-------------------------------------------"
			//~ + "\n mode=" + mode 
			//~ + "\n title=" + title
			//~ + "\n url=" + url
			//~ + "\n sel=" + sel
	//~ );
}

/**
 * startup functions
 */
var copyurlplusMenuItems = new Array('copyurlplus-sel', 'copyurlplus-titlesel');

function copyurlplusContext() {
	if (gContextMenu) {
		//~ show = (gContextMenu.onLink && (fetchLink()));
		show = gContextMenu.isTextSelected;
		for (var i=0; i<copyurlplusMenuItems.length; i++) {
			var menuitem = document.getElementById(copyurlplusMenuItems[i]);
			if (menuitem)
				menuitem.hidden = !show;
		}
	}
}


function init() {
	var menu = document.getElementById("contentAreaContextMenu");
	menu.addEventListener("popupshowing", copyurlplusContext, false);
}

window.addEventListener("load", init, false);
